Object subclass: #EnchantingFunction
	instanceVariableNames: 'source type index '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Enchanting'!
!EnchantingFunction commentStamp: '<historical>' prior: 0!
An enchanting function is a structure to keep tabs on some of the details of a function that will be exported.

name - the name of the function (perhaps 'GreenFlagClicked003')
type - the type of the function (perhaps #greenFlag)
source - the source code of the function
   perhaps something like:

       define GreenFlagClicked003:
          while true:
              x _ x + 1
              print x
   

	It will of course vary depending on the stack of blocks used and the language it is exported to.!


!EnchantingFunction methodsFor: 'accessors' stamp: 'CWB 8/21/2010 10:17'!
index
	^ index! !

!EnchantingFunction methodsFor: 'accessors' stamp: 'CWB 8/21/2010 10:17'!
index: anIndex
	index _ anIndex! !

!EnchantingFunction methodsFor: 'accessors' stamp: 'CWB 8/19/2010 09:44'!
source
	^ source! !

!EnchantingFunction methodsFor: 'accessors' stamp: 'CWB 8/19/2010 09:45'!
source: theSource
	source _ theSource! !

!EnchantingFunction methodsFor: 'accessors' stamp: 'CWB 8/19/2010 09:44'!
type
	^ type! !

!EnchantingFunction methodsFor: 'accessors' stamp: 'CWB 8/19/2010 09:44'!
type: aType
	type _ aType! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

EnchantingFunction class
	instanceVariableNames: ''!

!EnchantingFunction class methodsFor: 'initialization' stamp: 'CWB 8/21/2010 10:18'!
newWithSource: theSource type: aType index: anIndex
	"Creates a new enchanting function"

	| f |
	f _ self new.
	f source: theSource.
	f type: aType.
	f index: anIndex.

	^ f! !
