SyntaxElementMorph subclass: #PaletteElementMorph
	instanceVariableNames: 'variables '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
addVarNames: aCollectionOfSymbols
	aCollectionOfSymbols do: [:each|
		self addVariableNamed: each asSymbol ]! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
addVariableNamed: aSymbol

	| v |
	v _ ObjectElementMorph new label: aSymbol asString.
	v color: self varColor.
	variables at: aSymbol put: v.
	self addMorph: v.
	self fit! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
drawOn: aCanvas 

^self! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
fit
	| x y bw2|
	bw2 _ self borderWidth * 2.

	variables isEmpty ifTrue: [
		self extent: 0@0.
		(owner respondsTo: #fit)
			ifTrue: [^owner fit]
			ifFalse: [^self]].

	self height: variables anyOne height + (bw2 * 2).
	x _ self left + bw2.
	y _ (self center - (variables anyOne extent // 2)) y.
	variables keys asSortedCollection do: [:vn |
		(variables at: vn) position: x @ y.
		x _ (variables at: vn) right + bw2.
		].
	self width: (x - self position x).

	(owner respondsTo: #fit)
		ifTrue: [^owner fit]! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
initialize
	super initialize.
	variables _ Dictionary new.
	color _ Color transparent.
	self fit! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
isPartsBin

	^ true
! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
ownerColor
	owner ifNotNil: [^owner color].
	^Color gray! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:27'!
removeVariable: element

	element delete.
	variables removeKey: element name asSymbol.
	self fit! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 21:28'!
rootForGrabOf: aMorph
	"I act like a parts bin; answer a new copy of the morph being extracted."

	| v |
	v _ aMorph ownerThatIsA: ObjectElementMorph.
	v ifNotNil: [^v fullCopy].

	(owner isKindOf: MethodElementMorph)
		ifTrue: [^owner rootForGrabOf: aMorph].
	^owner! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 21:31'!
varColor
	| oc |
	oc _ owner color.
	^Color
		h: oc hue s: 0.5 v: 0.5
"	^owner color mixed: 0.93 with: Color black"! !

!PaletteElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:35'!
variableNames
	^variables collect: [:m| m name ]! !
