HostSystemMenusMacOSX subclass: #HostSystemMenusMacOSXScratch
	instanceVariableNames: 'applicationQuitMenuItem editReaderModeMenuItem '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusMacOSXScratch methodsFor: 'menu installation' stamp: 'JMM 12/21/2006 00:11'!
appendStandardWindowMenu: inOptions
! !

!HostSystemMenusMacOSXScratch methodsFor: 'menu installation' stamp: 'jens 4/28/2010 23:47'!
rebuildApplicationMenuHandlers: aMenuRef using: aMenuBarMgr

	| maximumItems applicationMenuItemsTitles applicationMenuItems m |
	maximumItems _ aMenuBarMgr countMenuItems: aMenuRef.
	applicationMenuItemsTitles _ (1 to: maximumItems) collect: [:i | aMenuBarMgr getMenuItemText: aMenuRef item: i].
	applicationMenuItems _ applicationMenuItemsTitles collect: [:e | HostSystemMenusMenuItem menuString: e].

	"attempt at allowing Macs to quit regardless of what the app name is (for BYOB, -jens)"
	applicationQuitMenuItem _ applicationMenuItems detect: [:e | e text beginsWith: 'Quit ' localized] ifNone: [nil].

	applicationQuitMenuItem ifNotNil: [
		applicationQuitMenuItem handler: [:evt | ScratchFrameMorph quitFromMenu]].
	m _ Dictionary new.
	applicationMenuItems doWithIndex: [:e :i | m at: i put: e].
	aMenuBarMgr menus at: (aMenuBarMgr getMenuID: aMenuRef) put: m.
! !

!HostSystemMenusMacOSXScratch methodsFor: 'menu installation' stamp: 'jm 12/31/2006 19:00'!
reviseHostMenus

	self reworkApplicationMenu: self.
	self deleteMenu: (self getMenuHandle: 2).	"delete file menu"
	self deleteMenu: (self getMenuHandle: 3).	"delete edit menu"

! !

!HostSystemMenusMacOSXScratch methodsFor: 'menu installation' stamp: 'jm 12/30/2006 21:45'!
reworkApplicationMenu: aMenuBarMgr

	| menuRef commandID menuItemIndex |
	commandID _ self osTypeFromCharString: 'hide'.
	menuRef _ aMenuBarMgr getIndMenuWithCommandID: 0 item: commandID.
	menuItemIndex _ aMenuBarMgr getIndMenuItemWithCommandID: 0 item: commandID.
	"aMenuBarMgr setItemCmd: menuRef item: menuItemIndex cmdChar: $H."
	self rebuildApplicationMenuHandlers: menuRef using: aMenuBarMgr.
	commandID _ self osTypeFromCharString: 'quit'.
	aMenuBarMgr enableMenuCommand: menuRef command: commandID.
	commandID _ self osTypeFromCharString: 'abou'.
	aMenuBarMgr enableMenuCommand: menuRef command: commandID.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HostSystemMenusMacOSXScratch class
	instanceVariableNames: ''!

!HostSystemMenusMacOSXScratch class methodsFor: 'instance creation' stamp: 'jm 12/30/2006 20:06'!
isActiveHostMenuProxyClass
	"Am I active?"

	^ Smalltalk platformName = 'Mac OS' and: [Smalltalk osVersion asNumber >= 1000]
! !
