ArgMorph subclass: #SpecialArgMorph
	instanceVariableNames: 'type skin '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-BYOB'!

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 23:25'!
acceptsDroppedReporters

	^ true
! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2010 23:25'!
acceptsTypeOf: aBlockMorph
	"Answer true if I can accept a dropped reporter of the given type. Answer false by default."

	^ true
! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 7/22/2010 22:23'!
drawOn: aCanvas

	(owner isKindOf: CReporterSlotMorph)
		ifTrue: [^ self].

	skin ifNil: [
		(owner isKindOf: BlockMorph) ifTrue: [
			#reporterslot = type
				ifTrue: [^ aCanvas fillOval: self bounds color: Color lightGray " (owner color mixed: 0.6 with: Color darkGray)" ]
				ifFalse: [

	| h s v darkerC lighterC right topY bottomY xInset c |

	color _ (owner color mixed: 0.6 with: Color darkGray).
	h _ color hue.
	s _ color saturation.
	v _ color brightness.
	darkerC _ Color h: h s: (s - 0.3) v: (v - 0.3).
	lighterC _ Color h: h s: (s - 0.2) v: (v + 0.2).

	color _ Color lightGray.

	right _ self width.
	topY _ bottomY _ self height // 2.
	self height even ifTrue: [topY _ bottomY - 1].
	xInset _ 0.
	[topY >= 0] whileTrue: [
		self drawHLineFrom: xInset to: (xInset + 2) y: topY color: darkerC on: aCanvas.
		c _ (topY <= 1) ifTrue: [darkerC] ifFalse: [color].
		self drawHLineFrom: xInset + 2 to: right - (xInset + 1) y: topY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 1)) to: (right - xInset) y: topY color: darkerC on: aCanvas.

		self drawHLineFrom: xInset to: (xInset + 1) y: bottomY color: lighterC on: aCanvas.
		c _ (bottomY >= (self height - 2)) ifTrue: [lighterC] ifFalse: [color].
		self drawHLineFrom: xInset + 1 to: right - (xInset + 1) y: bottomY color: c on: aCanvas.
		self drawHLineFrom: (right - (xInset + 2)) to: (right - xInset) y: bottomY color: lighterC on: aCanvas.

		xInset _ xInset + 1.	
		bottomY _ bottomY + 1.
		topY _ topY - 1].
^self

]
		]].

	aCanvas paintImage: skin at: self position! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2010 00:22'!
evaluate

	implicitValue notNil
		ifTrue: [^implicitValue].
	^nil
! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/25/2010 15:20'!
stringExpression: obj

	"default is not to do anything"! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 3/22/2010 22:14'!
type
	^type! !

!SpecialArgMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/14/2011 01:40'!
type: aSymbol

	"currently BYOB supports the following first class types:

    #none		- a puzzle shaped command block
    #any		- a non-typed round reporter block (can be anything)
*    #string		- a round reporter block that answers a string
    #number	- a round reporter block that answers a number
*    #list			- a round reporter block that answers a number
    #boolean	- a hexagonal reporter block that answers a boolean
*    #command	- a round reporter block that answers a procedure (a command block)
*    #reporter	- a round reporter block that answers a function (a reporter block)
*    #predicate	- a hexagonal reporter block that answers a reporter of a boolean 
    #template	- a sunken variable blob that represents an externalized block variable
*   #reporterslot
*	#booleanslot
*	*objSlot

the ones marked by asterix (*) are represented by this class
"
	type _ aSymbol.
	#objSlot = type ifTrue: [
		skin _ ScratchFrameMorph skinAt: #objSlot].
	(#(reporterslot booleanslot objSlot) includes: type) ifFalse: [
		skin _ ScratchFrameMorph skinAt: ('type', type asString capitalized) asSymbol].
	self 
		borderWidth: 0;
		cornerStyle: #square;
		extent: (skin ifNil: [type = #reporterslot ifTrue: [18@12] ifFalse: [23@14]] ifNotNil: [skin extent]).! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SpecialArgMorph class
	instanceVariableNames: ''!

!SpecialArgMorph class methodsFor: 'as yet unclassified' stamp: 'JM 8/3/2011 16:50'!
example
	| script dict block |
	"self example"

	script _ nil.
	dict _ Dictionary new.
	dict
		at: 'Any type' put: '%s';
		at: 'Number' put: '%n';
		at: 'Boolean (T/F)' put: '%b';
		at: 'Text' put: '%T';
		at: 'List' put: '%t';
		at: 'Command' put: '%o';
		at: 'Reporter' put: '%r';
		at: 'Predicate (Reporter of Boolean)' put: '%6'.

	dict keysDo: [:key |
		block _ CommandBlockMorph new
			commandSpec: key, ': ', (dict at: key).
		script
			ifNil: [script _ block]
			ifNotNil: [script bottomBlock attachBlock: block]].
	script openInWorld! !
